;  TEST370.ASM - Test file for TMS370 disassembler
;
;  This file has been assembled with the Texas Instruments TMS370
;  assembler SA370.
;  CAUTION:  this assembler does not detect out of range relative
;  branch instructions!  Be very careful if you add code!
;
;  11-Jul-95 BY JOHN HARTMAN
;
;  EQUATES FOR ADDRESS MODES
NN	.equ	12H	    ;IMMEDIATE 8
MM	.equ	56H
PNNN	.equ	1034H	    ;PORT
NNNN	.equ	789AH	    ;value

	.TEXT	 9000h
;
;  How bad are relative jumps?
        JMP     $+2		;offset 0
        JMP     $+127		;offset 7D
        JMP     $+128		;offset 7E
        JMP     $+129		;offset 7F
        JMP     $+130           ;SHOULD BE OUT OF RANGE, get offset 80
        JMP     $+131           ;SHOULD BE OUT OF RANGE, get offset 81
        JMP     $-126		;offset 80
        JMP     $-127           ;SHOULD BE OUT OF RANGE, get offset 7F
        JMP     $-128           ;SHOULD BE OUT OF RANGE, get offset 7E
        JMP     $-129           ;SHOULD BE OUT OF RANGE, get offset 7D
;
;  Numerical list of op-codes
LLLL:	JMP	LLL1		; 00
	JN	LLL1		; 01
	JZ	LLL1		; 02
	JC	LLL1		; 03
	JP	LLL1		; 04
	JPZ	LLL1		; 05
	JNZ	LLL1		; 06
	JNC	LLL1		; 07
	JV	LLL1		; 08
	JL	LLL1		; 09
	JLE	LLL1		; 0A
	JHS	LLL1		; 0B
	JNV	LLL1		; 0C
	JGE	LLL1		; 0D
	JG	LLL1		; 0E
	JLO	LLL1		; 0F
;
	.page
	.BYTE	10H		; 10
	.BYTE	11H		; 11
LLL1:   MOV     NN,A            ; 12
        AND     NN,A            ; 13
        OR      NN,A            ; 14
        XOR     NN,A            ; 15
        BTJO    NN,A,LLL1       ; 16
        BTJZ    NN,A,LLL1       ; 17
        ADD     NN,A            ; 18
        ADC     NN,A            ; 19
        SUB     NN,A            ; 1A
        SBB     NN,A            ; 1B
        MPY     NN,A            ; 1C
        CMP     NN,A            ; 1D
        DAC     NN,A            ; 1E
        DSB     NN,A            ; 1F
;
	.page
	.BYTE	20H		; 20
	MOV	A,PNNN		; 21
        MOV     #NN,A           ; 22
        AND     #NN,A           ; 23
        OR      #NN,A           ; 24
        XOR     #NN,A           ; 25
        BTJO    #NN,A,LLL1      ; 26
        BTJZ    #NN,A,LLL1      ; 27
        ADD     #NN,A           ; 28
        ADC     #NN,A           ; 29
        SUB     #NN,A           ; 2A
        SBB     #NN,A           ; 2B
        MPY     #NN,A           ; 2C
        CMP     #NN,A           ; 2D
        DAC     #NN,A           ; 2E
        DSB     #NN,A           ; 2F
;
	.BYTE	30H		; 30
	.BYTE	31H		; 31
        MOV     NN,B            ; 32
        AND     NN,B            ; 33
        OR      NN,B            ; 34
        XOR     NN,B            ; 35
        BTJO    NN,B,LLL1       ; 36
        BTJZ    NN,B,LLL1       ; 37
        ADD     NN,B            ; 38
        ADC     NN,B            ; 39
        SUB     NN,B            ; 3A
        SBB     NN,B            ; 3B
        MPY     NN,B            ; 3C
        CMP     NN,B            ; 3D
        DAC     NN,B            ; 3E
        DSB     NN,B            ; 3F
;
	.BYTE	40H		; 40
	.BYTE	41H		; 41
        MOV     NN,MM           ; 42
        AND     NN,MM           ; 43
        OR      NN,MM           ; 44
        XOR     NN,MM           ; 45
        BTJO    NN,MM,LLL1      ; 46
        BTJZ    NN,MM,LLL1      ; 47
        ADD     NN,MM           ; 48
        ADC     NN,MM           ; 49
        SUB     NN,MM           ; 4A
        SBB     NN,MM           ; 4B
        MPY     NN,MM           ; 4C
        CMP     NN,MM           ; 4D
        DAC     NN,MM           ; 4E
        DSB     NN,MM           ; 4F
;
	.BYTE	50H		; 50
LLL1A:	MOV	B,PNNN		; 51
        MOV     #NN,B           ; 52
        AND     #NN,B           ; 53
        OR      #NN,B           ; 54
        XOR     #NN,B           ; 55
        BTJO    #NN,B,LLL1A     ; 56
        BTJZ    #NN,B,LLL1A     ; 57
        ADD     #NN,B           ; 58
        ADC     #NN,B           ; 59
        SUB     #NN,B           ; 5A
        SBB     #NN,B           ; 5B
        MPY     #NN,B           ; 5C
        CMP     #NN,B           ; 5D
        DAC     #NN,B           ; 5E
        DSB     #NN,B           ; 5F
;
	.BYTE	60H		; 60
	.BYTE	61H		; 61
        MOV     B,A             ; 62
        AND     B,A             ; 63
        OR      B,A             ; 64
        XOR     B,A             ; 65
        BTJO    B,A,LLL1A       ; 66
        BTJZ    B,A,LLL1A       ; 67
        ADD     B,A             ; 68
        ADC     B,A             ; 69
        SUB     B,A             ; 6A
        SBB     B,A             ; 6B
        MPY     B,A             ; 6C
        CMP     B,A             ; 6D
        DAC     B,A             ; 6E
        DSB     B,A             ; 6F
;
	INCW	#NN,MM		; 70
	MOV	NN,PNNN		; 71
        MOV     #NN,MM          ; 72
        AND     #NN,MM          ; 73
        OR      #NN,MM          ; 74
        XOR     #NN,MM          ; 75
        BTJO    #NN,MM,LLL1A    ; 76
        BTJZ    #NN,MM,LLL1A    ; 77
        ADD     #NN,MM          ; 78
        ADC     #NN,MM          ; 79
        SUB     #NN,MM          ; 7A
        SBB     #NN,MM          ; 7B
        MPY     #NN,MM          ; 7C
        CMP     #NN,MM          ; 7D
        DAC     #NN,MM          ; 7E
        DSB     #NN,MM          ; 7F
;
	MOV	PNNN,A		; 80
	.BYTE	81H		; 81
	.BYTE	82H		; 82
        AND     A,PNNN          ; 83
        OR      A,PNNN          ; 84
        XOR     A,PNNN          ; 85
        BTJO    A,PNNN,LLL2     ; 86
        BTJZ    A,PNNN,LLL2     ; 87
        MOVW    #NNNN,NN        ; 88
        JMPL    LLL2            ; 89
        MOV     NNNN,A          ; 8A
        MOV     A,NNNN          ; 8B
        BR      LLL2            ; 8C
        CMP     NNNN,A          ; 8D
        CALL    LLL2            ; 8E
        CALLR	LLL2            ; 8F
;
	.BYTE	90H		; 90
	MOV	PNNN,B		; 91
	.BYTE	92H		; 92
        AND     B,PNNN          ; 93
        OR      B,PNNN          ; 94
        XOR     B,PNNN          ; 95
        BTJO    B,PNNN,LLL2     ; 96
        BTJZ    B,PNNN,LLL2     ; 97
        MOVW    NN,MM           ; 98
        JMPL    @NN             ; 99
        MOV     @NN,A           ; 9A
        MOV     A,@NN           ; 9B
        BR      @NN             ; 9C
        CMP     @NN,A           ; 9D
        CALL    @NN             ; 9E
        CALLR   @NN             ; 9F
;
	.BYTE	0A0H		; A0
	.BYTE	0A1H		; A1
        MOV     PNNN,NN         ; A2
        AND     #NN,PNNN        ; A3
        OR      #NN,PNNN        ; A4
        XOR     #NN,PNNN        ; A5
        BTJO    #NN,PNNN,LLL2   ; A6
        BTJZ    #NN,PNNN,LLL2   ; A7
        MOVW    #NNNN(B),MM     ; A8
        JMPL    LLL2(B)         ; A9
        MOV     NNNN(B),A       ; AA
        MOV     A,NNNN(B)       ; AB
        BR      LLL2(B)         ; AC
        CMP     NNNN(B),A       ; AD
        CALL    NNNN(B)         ; AE
        CALLR   NNNN(B)         ; AF
;
LLL2:	CLRC                    ; B0
        TST     A               ; B0
        .BYTE   0B1H            ; B1
        DEC     A               ; B2
        INC     A               ; B3
        INV     A               ; B4
        CLR     A               ; B5
        XCHB    A               ; B6
        SWAP    A               ; B7
        PUSH    A               ; B8
        POP     A               ; B9
        DJNZ    A,LLL2          ; BA
        COMPL   A               ; BB
        RR      A               ; BC
        RRC     A               ; BD
        RL      A               ; BE
        RLC     A               ; BF
;
	MOV	A,B		; C0
        .BYTE    0C1H           ; C1
        DEC     B               ; C2
        INC     B               ; C3
        INV     B               ; C4
        CLR     B               ; C5
        TST     B               ; C6
        SWAP    B               ; C7
        PUSH    B               ; C8
        POP     B               ; C9
        DJNZ    B,LLL2          ; CA
        COMPL   B               ; CB
        RR      B               ; CC
        RRC     B               ; CD
        RL      B               ; CE
        RLC     B               ; CF
;               
	MOV	A,NN		; D0                  
        MOV	B,NN            ; D1
        DEC     NN              ; D2
        INC     NN              ; D3
        INV     NN              ; D4
        CLR     NN              ; D5
        XCHB    NN              ; D6
        SWAP    NN              ; D7
        PUSH    NN              ; D8
        POP     NN              ; D9
        DJNZ    NN,LLL2         ; DA
        COMPL   NN              ; DB
        RR      NN              ; DC
        RRC     NN              ; DD
        RL      NN              ; DE
        RLC     NN              ; DF
;
	TRAP	15		; E0
	TRAP	14		; E1
	TRAP	13		; E2
	TRAP	12		; E3
	TRAP	11		; E4
	TRAP	10		; E5
	TRAP	9		; E6
	TRAP	8		; E7
	TRAP	7		; E8
	TRAP	6		; E9
	TRAP	5		; EA
	TRAP	4		; EB
	TRAP	3		; EC
	TRAP	2		; ED
	TRAP	1		; EE
	TRAP	0		; EF
;
	LDST	#NN		; F0
	MOV	NN(SP),A	; F1
	MOV	A,NN(SP)	; F2
	CMP	MM(SP),A	; F3
;
;  EXTENDED			; F4
	MOVW	#NN(MM),A	; F4E8
	JMPL	NN(MM)		; F4E9
	MOV	NN(MM),A	; F4EA
	MOV	A,NN(MM)	; F4EB
	BR	NN(MM)		; F4EC
	BR	-NN(MM)		; F4EC
	CMP	NN(MM),A	; F4ED
	CALL	NN(MM)		; F4EE
	CALL	-NN(MM)		; F4EE
	CALLR	NN(MM)		; F4EF
	CALLR	-NN(MM)		; F4EF
	;
	DIV	NN,A		; F4F8
	.BYTE	0F4H,0F9H	; F4F9
;
	.BYTE	0F5H		; F5
	IDLE			; F6
	MOV	#NN,PNNN	; F7
	SETC			; F8
	RTS			; F9
	RTI			; FA
	PUSH	ST		; FB
	POP	ST		; FC
	LDSP			; FD
	STSP			; FE
	NOP			; FF
;
;  Jump tests
L0:	JMP	L1
	NOP
L1:	MOV	#1,A
	BTJO    #1,A,L2
	NOP
L2:	BTJZ    #1,A,LN3
	NOP
;
;  Label
LN3:    JMPL    LN4
        NOP
LN4:	BR      LN5
        NOP
LN5:	CALL    SR1
	NOP
	CALLR	SR1
	NOP
;
;  Register indirect
LA3:    MOVW	#LA4-LA3A,NN
	JMPL    @NN
LA3A:	NOP
LA4:    MOVW	#LA5,NN
	BR      @NN
        NOP
LA5:    MOVW	#SR1,NN
	CALL    @NN
	NOP
	MOVW	#SR1-LA5A,NN
	CALLR	@NN
LA5A:	NOP
;
LB3:    MOV	#0,B
	JMPL    #LB4(B)
	NOP
LB4:    MOV     #2,B
        BR      #LB5-2(B)
        NOP
LB5:	CALL    #SR1-2(B)
	NOP
	CALLR	#SR1-2(B)
	NOP
;
LNN3:   MOVW	#1,NN
	JMPL    2(NN)
        NOP
        NOP
        NOP
LNN4:   MOVW	#LNN5-2,NN
	BR      2(NN)
        NOP
LNN5:   MOVW	#SR1+2,NN
	CALL    -2(NN)
	NOP
	MOVW	#SR1-LNN5A+2,NN
	CALLR	-2(NN)
LNN5A:	NOP

	MOV	#4,A
LNN6:	NOP
        DJNZ    A,LNN6
	NOP

	PUSH	ST
	CALL	II1	;FAKE INTERRUPT
        NOP

SR1:	NOP
	RTS
	NOP
	NOP

II1:	NOP
	RTI
        NOP
        NOP

	JMPL	0(B)		;absolute numbers
        JMPL	100(B)
        JMPL	9000H(B)
        JMPL	QQQQ(B)		;label
        JMPL	NN(B)		;short equate
        JMPL	NNNN(B)		;long equate
        NOP
QQQQ:	NOP
;
;  Test Watchdog timeout
	MOV	P04A,A
        AND	#0DFH,P04A
        OR	#00H,P04A
	MOV	P04A,B
        JMP	QQQQ


	OR	#80H,P04A	;enable reset by WDT
;
	MOV	#0,A
        MOV	#0,B
QRS:	INC	A		;WASTE TIME
	JNZ	QRS
        INC	B
        JNZ	QRS
        NOP
        JMP	QRS
